Module Test
    Sub Main()
        Dim Enumerator As New FileSystemEnumerator
        AddHandler Enumerator.FileFound, AddressOf File
        AddHandler Enumerator.DirectoryFound, AddressOf Directory
        AddHandler Enumerator.ErrorOccoured, AddressOf [Error]

        With Enumerator
            .StartDirectory = New IO.DirectoryInfo("C:\Windows")
            .EnumerationStatus = FileSystemEnumerator.EnumerationType.OnlyFiles
            .Enumerate()
            'Listet alle Dateien im Verzeichniss C:\Windows und smtlichen
            'Unterordnern auf.
        End With

        With Enumerator
            .StartDirectory = New IO.DirectoryInfo("C:\Programme")
            .EnumerationStatus = FileSystemEnumerator.EnumerationType.OnlyDirs
            .Enumerate()
            'Listet alle Ordner im Verzeichniss C:\Programme auf
            'und verarbeitet dann die Unterordner dieser Ordner ...
        End With

        With Enumerator
            .StartDirectory = New IO.DirectoryInfo("D:\Daten")
            .EnumerationStatus = FileSystemEnumerator.EnumerationType.Both
            .Enumerate()
            'Listet alle Ordner und Dateien im Verzeichniss D:\Daten
            ' und smtlichen Unterordnern auf.
        End With
    End Sub

    Private Sub File(ByVal File As IO.FileInfo)
        Console.WriteLine("Gefunde Datei: {0}", File.FullName)
    End Sub

    Private Sub Directory(ByVal Directory As IO.DirectoryInfo, _
      ByRef ContinueRecursion As Boolean)
        Console.WriteLine("Gefunder Ordner: {0}", Directory.FullName)
        'Um die Unterordner von C:\Windows\System32 auszuschlieen:
        If Directory.FullName.StartsWith("C:\Windows\System32") Then
            ContinueRecursion = False
        End If
    End Sub

    Private Sub [Error](ByVal ex As Exception)
        Console.WriteLine("Fehler: {0}", ex.Message)
    End Sub
End Module
